<template>
  <!-- CreateCircuit Form -->
  <form id="create-circuit-form" class="w-full">

    <!-- Circuit icon -->
    <CircuitIcon
      width="120"
      :fill="GLOBALS.__THEME_DARK_3_COLOR__"
      :type="typeValue"
      class="mx-auto"
    />

    <!-- Text content -->
    <p class="text-center text-xl mb-4">{{ $t('circuit.createCircuit') | capitalize }}</p>

    <!-- Error messages -->
    <t-alert v-if="form.globalError" variant="error" class="mb-8" show>
      <p class="text-error">{{ form.globalError }}</p>
    </t-alert>

    <!-- Type -->
    <RichSelect
      v-model="typeValue"
      name="type"
      :state="typeState"
      :label="$h.capitalize($t('circuit.type'))"
      :placeholder="$h.capitalize($t('global.select'))"
      :error="getFieldErrorMessage('type')"
      :options="[
        { value: 'valve',       text: $h.capitalize($t('circuit.valveType')) },
        { value: 'water_inlet', text: $h.capitalize($t('circuit.waterInletType')) }
      ]"
      :multiple="false"
      :clearable="false"
      required
      hideSearchBox
      fluid
      class="mb-4"
    />

    <!-- Channel -->
    <RichSelect
      v-model="channelValue"
      name="channel"
      :state="channelState"
      :label="$h.capitalize($t('circuit.channel'))"
      :placeholder="$h.capitalize($t('global.select'))"
      :description="$h.capitalize($t('circuit.onlyAvailableChannelsAreDisplayed'))"
      :error="getFieldErrorMessage('channel')"
      :options="availableChannels"
      :multiple="false"
      :clearable="false"
      required
      hideSearchBox
      fluid
      class="mb-4"
    />

    <!-- Name -->
    <Input
      v-model="nameValue"
      name="name"
      :variant="nameState ? 'primary' : 'error'"
      :state="nameState"
      :label="$h.capitalize($t('global.name'))"
      :placeholder="$h.capitalize($t('global.name'))"
      :error="getFieldErrorMessage('name')"
      required
      fluid
      class="mb-4"
    />

    <!-- Color -->

    <div class="mb-2">
      <label>{{ $t('global.color') | capitalize }} *</label>
    </div>

    <!-- Picker -->
    <ColorPicker
      :color="colorValue"
      @update="pickColor"
      class="w-full mb-4"
    />

    <!-- Input -->
    <div id="_color-input-container">
      <div id="_color-input-indicator" :style="`background-color: ${colorValue};`"></div>

      <Input
        v-model="colorValue"
        id="_color-input"
        name="color"
        :variant="colorState ? 'primary' : 'error'"
        :state="colorState"
        :placeholder="$h.capitalize($t('global.color'))"
        :error="getFieldErrorMessage('color')"
        fluid
        class="mb-4"
      />
    </div>

    <!-- Description -->
    <Input
      v-model="descriptionValue"
      name="description"
      :variant="descriptionState ? 'primary' : 'error'"
      :state="descriptionState"
      :label="`${$h.capitalize($t('global.description'))} (${$t('global.optional')})`"
      :placeholder="$h.capitalize($t('global.description'))"
      :error="getFieldErrorMessage('description')"
      fluid
      class="mb-4"
    />

    <div class="flex justify-center">

      <!-- Confirm button -->
      <Button
        variant="primary"
        :disabled="!(isFormValid && hasChanged)"
        @click.native="handleOk"
        inline
        class="mr-4"
      >
        {{ $t('global.create') | capitalize }}
      </Button>

      <!-- Cancel button -->
      <Button
        variant="error"
        @click.native="handleCancel"
        inline
      >
        {{ $t('global.cancel') | capitalize }}
      </Button>

    </div>

  </form>

</template>

<script>
// vuex helpers
import { mapState, mapActions } from 'vuex'
// BaseForm
import BaseForm from '@/components/commons/form/BaseForm'
// utils
import { isDef, isNull, validateHexColor } from '#utils'

/**
 * CreateCircuitForm component
 */
export default {
  name: 'CreateCircuitForm',
  extends: BaseForm,
  props: {
    /**
     * okAppend
     */
    okAppend: {
      type: Function,
      default: function () {
        // ...
      }
    },
    /**
     * cancelAppend
     */
    cancelAppend: {
      type: Function,
      default: function () {
        // ...
      }
    }
  },
  // 'form' option (see src/components/commons/form/BaseForm)
  form: {
    fields: {
      /**
       * channel
       */
      channel: {
        // Default: generate 'channelValue' & 'channelChanged'
        default: function () {
          return null
        },
        // Generate: 'channelState'
        state: function () {
          return !this.isFieldInError('channel') // No errors ?
            ? this.isChannelValid // Valid ?
            : false
        },
        // Generate: 'isChannelValid'
        isValid: function () {
          return isDef(this.channelValue) && !isNull(this.channelValue)
        }
      },
      /**
       * name
       */
      name: {
        // Default: generate 'nameValue' & 'nameChanged'
        default: function () {
          return ''
        },
        // Generate: 'nameState'
        state: function () {
          return !this.isFieldInError('name') // No errors ?
            ? this.nameValue.length > 0 // Filled ?
              ? this.isNameValid // Valid ?
              : true
            : false // else -> errors
        },
        // Generate: 'isNameValid'
        isValid: function () {
          return this.nameValue.length > 0
        }
      },
      /**
       * color
       */
      color: {
        // Default: generate 'colorValue' & 'colorChanged'
        default: function () {
          return '#FF2255'
        },
        // Generate: 'colorState'
        state: function () {
          return !this.isFieldInError('color') // No errors ?
            ? this.isColorValid // Valid ?
            : false
        },
        // Generate: 'isColorValid'
        isValid: function () {
          return validateHexColor(this.colorValue)
        }
      },
      /**
       * type
       */
      type: {
        // Default: generate 'typeValue' & 'typeChanged'
        default: function () {
          return 'valve'
        },
        // Generate: 'typeState'
        state: function () {
          return !this.isFieldInError('type') // No errors ?
            ? this.isTypeValid // Valid ?
            : false
        },
        // Generate: 'isTypeValid'
        isValid: function () {
          return this.typeValue === 'valve' || this.typeValue === 'water_inlet'
        }
      },
      /**
       * description
       */
      description: {
        // Default: generate 'descriptionValue' & 'descriptionChanged'
        default: function () {
          return ''
        },
        // Generate: 'descriptionState'
        state: function () {
          return !this.isFieldInError('description') // No errors ?
            ? this.isDescriptionValid // Valid ?
            : false
        }
      }
    }
  },
  computed: {
    // Map state from Circuits module
    ...mapState('Circuits', {
      circuits: 'circuits'
    }),
    /**
     * availableChannels
     * @description Return available channels
     * @return {number[]}
     */
    availableChannels: function () {
      const defaultChannels = [1, 2, 3, 4]
      const usedChannels = this.circuits.map((circuit) => {
        return circuit.channel
      })
      return defaultChannels.filter((num) => {
        if (!usedChannels.includes(num)) {
          return num
        }
      })
    }
  },
  methods: {
    // Map actions from 'Circuits' store module
    ...mapActions('Circuits', [
      'loadCircuits',
      'getCircuitStatus',
      'createCircuit'
    ]),
    /**
     * Pick color
     * @param {Object} value
     */
    pickColor: function (value) {
      this.colorValue = value.hex
    },
    /**
     * Handle click on 'confirm' submit button.
     * @param {Object} evt - The event payload
     * @returns {void}
     */
    handleOk (evt) {
      // Prevent click
      evt.preventDefault()
      // Reset errors before
      this.resetErrors()
      // Create circuit data
      this.saveData()
      // What to do at the end of handleOk
      this.okAppend()
    },
    /**
     * Handle click on 'cancel' button.
     * @param {Object} evt - The event payload
     * @returns {void}
     */
    handleCancel (evt) {
      // Prevent click
      evt.preventDefault()
      // Reset errors
      this.resetErrors()
      // Reset form
      this.resetForm()
      // What to do at the end of handleCancel
      this.cancelAppend()
    },
    /**
     * Handle click on data 'save' button.
     * @returns {void}
     */
    async saveData () {
      // Wait for create circuit function
      const createCircuitResponse = await this.createCircuit({
        channel: this.channelValue,
        name: this.nameValue,
        color: this.colorValue,
        type: this.typeValue,
        description: this.descriptionValue
      })
      // If passed
      if (!(createCircuitResponse instanceof Error)) {
        // Reload circuits
        await this.loadCircuits()
        // Loop on circuits
        for (const circuit of this.circuits) {
          // Get & set circuit status
          this.getCircuitStatus(circuit.id)
        }
        // Reset form
        this.resetForm()
      // Else parse server error
      } else {
        this.setFormErrors(createCircuitResponse) // Set form errors from response
      }
    }
  }
}
</script>

<style lang="scss">
#_color-input-container {
  @apply relative;

  #_color-input-indicator {
    @apply absolute;
    @apply w-4 h-4;
    @apply rounded-full;
    @apply left-3;
    top: 14px;
  }

  #_color-input {
    ._input {
      input {
        @apply pl-8;
      }
    }
  }
}
</style>
